<?php

/*
 * Class Name : GFHANNANSMS_Pro_{strtoupper( php file name) }	
 */

class GFHANNANSMS_Pro_HERO_SMS {

	/*
	* Gateway title
	*/
	public static function name( $gateways ) {

		$name = __( 'Hero-Sms (هیرو)', 'GF_SMS' );

		$gateway = array( strtolower( str_replace( 'GFHANNANSMS_Pro_', '', get_called_class() ) ) => $name );

		return array_unique( array_merge( $gateways, $gateway ) );
	}


	/*
	* Gateway parameters
	*/
	public static function options() {
		return array(
			'token' => __( 'توکن', 'GF_SMS' ),
		);
	}

	/*
	* Gateway credit
	*/
	public static function credit() {
		return true;
	}


	/*
	* Gateway action
	*/
	public static function process( $options, $action, $from, $to, $messages ) {

		if ( $action == 'credit' && ! self::credit() ) {
			return false;
		}

		$token = $options['token'];

		$to = explode( ',', $to );
		$i  = sizeOf( $to );
		while ( $i -- ) {
			$uNumber = trim( $to[ $i ] );
			$ret     = &$uNumber;
			if ( substr( $uNumber, 0, 5 ) == '%2B98' ) {
				$ret = substr( $uNumber, 5 );
			}
			if ( substr( $uNumber, 0, 5 ) == '%2b98' ) {
				$ret = substr( $uNumber, 5 );
			}
			if ( substr( $uNumber, 0, 4 ) == '0098' ) {
				$ret = substr( $uNumber, 4 );
			}
			if ( substr( $uNumber, 0, 3 ) == '098' ) {
				$ret = substr( $uNumber, 3 );
			}
			if ( substr( $uNumber, 0, 3 ) == '+98' ) {
				$ret = substr( $uNumber, 3 );
			}
			if ( substr( $uNumber, 0, 2 ) == '98' ) {
				$ret = substr( $uNumber, 2 );
			}
			$to[ $i ] = '98' . $ret;
		}
		unset( $ret );

		if ( $action == "send" ) {

			try {

				$soap = new SoapClient( "http://my.hiro-sms.com/wbs/send.php?wsdl" );

				$soap->token = $token;
				$soap->fromNum  = $from;
				$soap->toNum    = $to;
				$soap->Content  = $messages;
				$soap->Type     = '0';

				$result = $soap->SendSMS( $soap->fromNum, $soap->toNum, $soap->Content, $soap->Type, $soap->token );

				if ( ! empty( $result[0] ) && $result[0] > 100 ) {
					return 'OK';
				}

				if ( ! empty( $result[1] ) ) {
					return $result[1];
				}

				return __( 'ارسال پیامک با خطا مواجه شد. اطلاعات ورودی را بررسی نمایید.', 'GF_SMS' );

			} catch ( Exception $ex ) {
				return $ex->getMessage();
			}
		}

		if ( $action == "credit" ) {

			try {
				$soap           = new SoapClient( "http://my.hiro-sms.com/wbs/send.php?wsdl" );
				$soap->token = $token;
				$result         = $soap->GetCredit( $soap->token);
				switch ( $result ) {
					case '0':
						return __( 'توکن اشتباه میباشد', 'GF_SMS' );
						break;
					case '5':
						return __( 'پنل کاربری غیرفعال است.', 'GF_SMS' );
						break;
					case '6':
						return __( 'پنل کاربری منقضی شده است.', 'GF_SMS' );
						break;
					default:
						return $result . ' ' . __( 'پیامک', 'GF_SMS' );
				}

			} catch ( Exception $ex ) {
				return $ex->getMessage();
			}
		}


		if ( $action == "range" ) {
			$min = 200;
			$max = 500;

			return array( "min" => $min, "max" => $max );
		}

	}


}