<?php
/*
 * Class Name : GFHANNANSMS_Pro_{strtoupper( php file name) }	
 */
class GFHANNANSMS_Pro_MAXSMS {

	/*
	* Gateway title	
	*/
	public static function name($gateways) {
	
		$name = __('مکث اس ام اس (سامانه 2)', 'GF_SMS' );
		
		$gateway = array( strtolower( str_replace( 'GFHANNANSMS_Pro_', '', get_called_class())) => $name );
		return array_unique( array_merge( $gateways , $gateway ) );
	}
	
	
	/*
	* Gateway parameters
	*/
	public static function options(){
		return array(
			'username'  => __('نام کاربری','GF_SMS'),
			'password'  => __('کلمه عبور','GF_SMS'),
		);
	}

	/*
	* Gateway credit
	*/
	public static function credit(){
		return true;
	}

	/*
	* Gateway action
	*/
	public static function process( $options, $action, $from, $to, $messages ){
		
		if ( $action == 'credit' && !self::credit() ) {
			return false;
		}
		
		if ( ! extension_loaded('soap') )
			return __('ماژول Soap بر روی هاست شما فعال نمی باشد .','GF_SMS');
		
		
		$username = $options['username'];
		$password = $options['password'];
		
		
		if ( substr($username,0,2)=='mx' ) {
		
			$account = array(
				'login' => $username,
				'password' => $password	
			);
			
			$to = explode(',', $to);
			$i = sizeOf($to);
			while($i--){
				$uNumber = Trim($to[$i]);
				$ret = &$uNumber;
				if (substr($uNumber,0, 5) == '%2B98'){ 
					$ret = substr($uNumber, 5);
				}
				if (substr($uNumber,0, 5) == '%2b98'){ 
					$ret = substr($uNumber, 5);
				}
				if (substr($uNumber,0, 4) == '0098'){ 
					$ret = substr($uNumber, 4);
				}
				if (substr($uNumber,0, 3) == '098')	{ 
					$ret = substr($uNumber, 3);
				}
				if (substr($uNumber,0, 3) == '+98'){ 
					$ret = substr($uNumber, 3);
				}
				if (substr($uNumber,0, 2) == '98'){ 
					$ret = substr($uNumber, 2);
				}
				$to[$i] =  '0' . $ret;
			}
					
			try {
				if ($action == "send") {
					$client = new SoapClient('http://sms.hostiran.net/webservice/?WSDL', $account);
					$send = $client->sendToMany( $to , $messages , $from);
				}
				if ($action == "credit") {
					$client = new SoapClient('http://sms.hostiran.net/webservice/?WSDL', $account);
					$info = $client->accountInfo();
					$credit = $info->remaining .' ریال ';
				}
		
			}
			catch (SoapFault $sf){
				$errorcode = $sf->faultcode;
				$errorstr = $sf->faultstring;
			}
			
			if ( !empty($errorcode) ||  !empty($errorstr) ) {
				return $errorstr." .";
			}
			else {

				if ($action == "send") {
					return 'OK';
				}

				if ($action == "credit") {
					return $credit;
				}

			}
			
			if ($action == "range"){
				$min = 5000;
				$max = 10000;
				return array("min" => $min, "max" => $max);
			}
		
		}

		
		if ( substr($username,0,3)=='max' ) {
			
			try {
				
				
				$fault = '';
				
				if ($action == "credit"){	
					$client = new SoapClient("http://87.107.121.52/post/send.asmx?wsdl");
					$getcredit_parameters = array(
						"username" => $username,
						"password" => $password
					);
					$credit = $client->GetCredit($getcredit_parameters)->GetCreditResult .' پیامک ';
				}
				
				if ($action == "send") {	
					
					$textMessage = iconv('UTF-8', 'UTF-8//TRANSLIT',$messages);
					$to = explode(',', $to);
					$i = sizeOf($to);
					while($i--){
						$uNumber = Trim($to[$i]);
						$ret = &$uNumber;
						if (substr($uNumber,0, 5) == '%2B98'){ 
							$ret = substr($uNumber, 5);
						}
						if (substr($uNumber,0, 5) == '%2b98'){ 
							$ret = substr($uNumber, 5);
						}
						if (substr($uNumber,0, 4) == '0098'){ 
							$ret = substr($uNumber, 4);
						}
						if (substr($uNumber,0, 3) == '098')	{ 
							$ret = substr($uNumber, 3);
						}
						if (substr($uNumber,0, 3) == '+98'){ 
							$ret = substr($uNumber, 3);
						}
						if (substr($uNumber,0, 2) == '98'){ 
							$ret = substr($uNumber, 2);
						}
						$to[$i] =  '0' . $ret;
					}
		
					$client = new SoapClient("http://87.107.121.52/post/send.asmx?wsdl");
					$sendsms_parameters = array(
						'username' 	=> $username,
						'password'  => $password,
						'from' 		=> $from,
						'to' 		=> $to,
						'text' 		=> $textMessage,
						'isflash' 	=> false,
						'udh' 		=> '',
						'recId' 	=> array(0),
						'status' 	=> 0
					);
					$status = $client->SendSms($sendsms_parameters)->SendSmsResult;
				}
			}
			catch (SoapFault $ex) {
				$fault = $ex->faultstring;
			}
			
			if ( !empty($fault) ) {
				return $fault;
			}
			else {
				
				if ($action == "credit") {
					if ( intval($credit) <= 0 ){
						return __('اعتبار شما صفر است و یا ممکن است نام کاربری و کلمه عبور اشتباه باشد .','GF_SMS');
					}
					else {
						return $credit;
					}
				}
			
				if ( $action == "send" ) {
					switch ($status) {
						
						case "1" :
							return 'OK';
							break;			
			
						case "0" :
							return __('نام کاربری یا کلمه عبور اشتباه است .','GF_SMS');
							break;
			
						case "2" :
							return __('اعتبار پیامک برای ارسال کافی نیست .','GF_SMS');
							break;
			
						case "3" :
							return __('محدودیت ارسال روزانه .','GF_SMS');
							break;
			
						case "4" :
							return __('محدودیت در حجم ارسال .','GF_SMS');
							break;
			
						case "5" :
							return __('شماره فرستنده اشتباه است .','GF_SMS');
							break;
			
						case "6" :
							return __('سامانه در حال بروز رسانی است .','GF_SMS');
							break;
							
						case "7" :
							return __('پیامک دارای کلمات فیلتر شده از سوی سایت وبسرویس می باشد .','GF_SMS');
							break;
							
						case "9" :
							return __('ارسال از خطوط عمومی توسط وب سرویس امکان پذیر نیست .','GF_SMS');
							break;
							
						case "10" :
							return __('کاربر مورد نظر فعال نیست .','GF_SMS');
							break;
			
						case "11" :
							return __('پیامک ارسال نشده است .','GF_SMS');
							break;
			
						case "12" :
							return __('مدارک کاربر کامل نشده است .','GF_SMS');
							break;
					}
				}
			}
	
			if ($action == "range"){
				$min = 50;
				$max = 100;
				return array("min" => $min, "max" => $max);
			}	
		}
		
	}
}